Index: branches/RWT/modules/vci_cc_vcache_wrapper/caba/source/src/vci_cc_vcache_wrapper.cpp
===================================================================
--- branches/RWT/modules/vci_cc_vcache_wrapper/caba/source/src/vci_cc_vcache_wrapper.cpp	(revision 824)
+++ branches/RWT/modules/vci_cc_vcache_wrapper/caba/source/src/vci_cc_vcache_wrapper.cpp	(revision 827)
@@ -37,5 +37,4 @@
 #define DEBUG_ICACHE        1
 #define DEBUG_CMD           0
-#define INSTRUMENTATION     1
 
 namespace soclib {
@@ -43,5 +42,5 @@
 
 namespace {
-const char *icache_fsm_state_str[] = {
+const char * icache_fsm_state_str[] = {
         "ICACHE_IDLE",
 
@@ -69,5 +68,5 @@
     };
 
-const char *dcache_fsm_state_str[] = {
+const char * dcache_fsm_state_str[] = {
         "DCACHE_IDLE",
 
@@ -122,5 +121,5 @@
     };
 
-const char *cmd_fsm_state_str[] = {
+const char * cmd_fsm_state_str[] = {
         "CMD_IDLE",
         "CMD_INS_MISS",
@@ -135,5 +134,5 @@
     };
 
-const char *vci_pktid_type_str[] = {
+const char * vci_pktid_type_str[] = {
         "TYPE_DATA_UNC",
         "TYPE_READ_DATA_MISS",
@@ -146,5 +145,5 @@
     };
 
-const char *vci_cmd_type_str[] = {
+const char * vci_cmd_type_str[] = {
         "NOP or STORE_COND",
         "READ",
@@ -153,5 +152,5 @@
     };
 
-const char *rsp_fsm_state_str[] = {
+const char * rsp_fsm_state_str[] = {
         "RSP_IDLE",
         "RSP_INS_MISS",
@@ -163,5 +162,5 @@
     };
 
-const char *cc_receive_fsm_state_str[] = {
+const char * cc_receive_fsm_state_str[] = {
         "CC_RECEIVE_IDLE",
         "CC_RECEIVE_BRDCAST_HEADER",
@@ -179,5 +178,5 @@
     };
 
-const char *cc_send_fsm_state_str[] = {
+const char * cc_send_fsm_state_str[] = {
         "CC_SEND_IDLE",
         "CC_SEND_CLEANUP_1",
@@ -199,26 +198,26 @@
 /////////////////////////////////
 tmpl(/**/)::VciCcVCacheWrapper(
-    sc_module_name          name,
-    const int               proc_id,
-    const MappingTable      &mtd,
-    const IntTab            &srcid,
-    const size_t            cc_global_id,
-    const size_t            itlb_ways,
-    const size_t            itlb_sets,
-    const size_t            dtlb_ways,
-    const size_t            dtlb_sets,
-    const size_t            icache_ways,
-    const size_t            icache_sets,
-    const size_t            icache_words,
-    const size_t            dcache_ways,
-    const size_t            dcache_sets,
-    const size_t            dcache_words,
-    const size_t            wbuf_nlines,
-    const size_t            wbuf_nwords,
-    const size_t            x_width,
-    const size_t            y_width,
-    const uint32_t          max_frozen_cycles,
-    const uint32_t          debug_start_cycle,
-    const bool              debug_ok )
+    sc_module_name     name,
+    const int          proc_id,
+    const MappingTable &mtd,
+    const IntTab       &srcid,
+    const size_t       cc_global_id,
+    const size_t       itlb_ways,
+    const size_t       itlb_sets,
+    const size_t       dtlb_ways,
+    const size_t       dtlb_sets,
+    const size_t       icache_ways,
+    const size_t       icache_sets,
+    const size_t       icache_words,
+    const size_t       dcache_ways,
+    const size_t       dcache_sets,
+    const size_t       dcache_words,
+    const size_t       wbuf_nlines,
+    const size_t       wbuf_nwords,
+    const size_t       x_width,
+    const size_t       y_width,
+    const uint32_t     max_frozen_cycles,
+    const uint32_t     debug_start_cycle,
+    const bool         debug_ok)
     : soclib::caba::BaseModule(name),
 
@@ -230,27 +229,27 @@
       p_dspin_clack("p_dspin_clack"),
 
-      m_cacheability_table( mtd.getCacheabilityTable() ),
-      m_srcid( mtd.indexForId(srcid) ),
-      m_cc_global_id( cc_global_id ),
-      m_nline_width( vci_param::N - (uint32_log2(dcache_words)) - 2 ),
-      m_itlb_ways( itlb_ways ),
-      m_itlb_sets( itlb_sets ),
-      m_dtlb_ways( dtlb_ways ),
-      m_dtlb_sets( dtlb_sets ),
-      m_icache_ways( icache_ways ),
-      m_icache_sets( icache_sets ),
-      m_icache_yzmask( (~0)<<(uint32_log2(icache_words) + 2) ),
-      m_icache_words( icache_words ),
-      m_dcache_ways( dcache_ways ),
-      m_dcache_sets( dcache_sets ),
-      m_dcache_yzmask( (~0)<<(uint32_log2(dcache_words) + 2) ),
-      m_dcache_words( dcache_words ),
-      m_x_width( x_width ),
-      m_y_width( y_width ),
-      m_proc_id( proc_id ),
-      m_max_frozen_cycles( max_frozen_cycles ),
-      m_paddr_nbits( vci_param::N ),
-      m_debug_start_cycle( debug_start_cycle ),
-      m_debug_ok( debug_ok ),
+      m_cacheability_table(mtd.getCacheabilityTable()),
+      m_srcid(mtd.indexForId(srcid)),
+      m_cc_global_id(cc_global_id),
+      m_nline_width(vci_param::N - (uint32_log2(dcache_words)) - 2),
+      m_itlb_ways(itlb_ways),
+      m_itlb_sets(itlb_sets),
+      m_dtlb_ways(dtlb_ways),
+      m_dtlb_sets(dtlb_sets),
+      m_icache_ways(icache_ways),
+      m_icache_sets(icache_sets),
+      m_icache_yzmask((~0) << (uint32_log2(icache_words) + 2)),
+      m_icache_words(icache_words),
+      m_dcache_ways(dcache_ways),
+      m_dcache_sets(dcache_sets),
+      m_dcache_yzmask((~0) << (uint32_log2(dcache_words) + 2)),
+      m_dcache_words(dcache_words),
+      m_x_width(x_width),
+      m_y_width(y_width),
+      m_proc_id(proc_id),
+      m_max_frozen_cycles(max_frozen_cycles),
+      m_paddr_nbits(vci_param::N),
+      m_debug_start_cycle(debug_start_cycle),
+      m_debug_ok(debug_ok),
       m_dcache_paddr_ext_reset(0),
       m_icache_paddr_ext_reset(0),
@@ -281,4 +280,8 @@
       r_icache_cc_need_write("r_icache_cc_need_write"),
 
+      r_icache_clack_req("r_icache_clack_req"),
+      r_icache_clack_way("r_icache_clack_way"),
+      r_icache_clack_set("r_icache_clack_set"),
+
       r_icache_flush_count("r_icache_flush_count"),
 
@@ -286,5 +289,5 @@
       r_icache_unc_req("r_icache_unc_req"),
 
-      r_icache_tlb_miss_req("r_icache_tlb_read_req"),
+      r_icache_tlb_miss_req("r_icache_tlb_miss_req"),
       r_icache_tlb_rsp_error("r_icache_tlb_rsp_error"),
 
@@ -297,4 +300,6 @@
       r_icache_cc_send_way("r_icache_cc_send_way"),
       r_icache_cc_send_updt_tab_idx("r_icache_cc_send_updt_tab_idx"),
+
+      r_icache_paddr_ext("r_icache_paddr_ext"),
 
       r_dcache_fsm("r_dcache_fsm"),
@@ -329,4 +334,9 @@
       r_dcache_vci_sc_data("r_dcache_vci_sc_data"),
 
+      r_cas_islocal("r_cas_islocal"),
+      r_cas_local_way("r_cas_local_way"),
+      r_cas_local_set("r_cas_local_set"),
+      r_cas_local_word("r_cas_local_word"),
+
       r_dcache_xtn_way("r_dcache_xtn_way"),
       r_dcache_xtn_set("r_dcache_xtn_set"),
@@ -337,9 +347,17 @@
       r_dcache_miss_set("r_dcache_miss_set"),
       r_dcache_miss_inval("r_dcache_miss_inval"),
+      r_dcache_miss_clack("r_dcache_miss_clack"),
 
       r_dcache_cc_way("r_dcache_cc_way"),
       r_dcache_cc_set("r_dcache_cc_set"),
+      r_dcache_cc_state("r_dcache_cc_state"),
       r_dcache_cc_word("r_dcache_cc_word"),
       r_dcache_cc_need_write("r_dcache_cc_need_write"),
+      r_dcache_cc_inval_addr("r_dcache_cc_inval_addr"),
+      r_dcache_cc_inval_data_cpt("r_dcache_cc_inval_data_cpt"),
+
+      r_dcache_clack_req("r_dcache_clack_req"),
+      r_dcache_clack_way("r_dcache_clack_way"),
+      r_dcache_clack_set("r_dcache_clack_set"),
 
       r_dcache_flush_count("r_dcache_flush_count"),
@@ -349,6 +367,10 @@
       r_dcache_tlb_vaddr("r_dcache_tlb_vaddr"),
       r_dcache_tlb_ins("r_dcache_tlb_ins"),
+      r_dcache_tlb_paddr("r_dcache_tlb_paddr"),
       r_dcache_tlb_pte_flags("r_dcache_tlb_pte_flags"),
       r_dcache_tlb_pte_ppn("r_dcache_tlb_pte_ppn"),
+      r_dcache_tlb_cache_way("r_dcache_tlb_cache_way"),
+      r_dcache_tlb_cache_set("r_dcache_tlb_cache_set"),
+      r_dcache_tlb_cache_word("r_dcache_tlb_cache_word"),
       r_dcache_tlb_way("r_dcache_tlb_way"),
       r_dcache_tlb_set("r_dcache_tlb_set"),
@@ -361,4 +383,6 @@
 
       r_dcache_cleanup_victim_req("r_dcache_cleanup_victim_req"),
+      r_dcache_cleanup_victim_line_ncc("r_dcache_cleanup_victim_line_ncc"),
+      r_dcache_cleanup_victim_updt_data("r_dcache_cleanup_victim_updt_data"),
       r_dcache_cleanup_victim_nline("r_dcache_cleanup_victim_nline"),
 
@@ -369,4 +393,19 @@
       r_dcache_cc_send_updt_tab_idx("r_dcache_cc_send_updt_tab_idx"),
 
+      r_dcache_cc_cleanup_updt_data("r_dcache_cc_cleanup_updt_data"),
+      r_dcache_cc_cleanup_line_ncc("r_dcache_cc_cleanup_line_ncc"),
+      r_dcache_dirty_save("r_dcache_dirty_save"),
+      r_cc_send_cpt_word("r_cc_send_cpt_word"),
+      r_dcache_miss_data_cpt("r_dcache_miss_data_cpt"),
+      r_dcache_miss_data_addr("r_dcache_miss_data_addr"),
+      r_dcache_xtn_flush_data_cpt("r_dcache_xtn_flush_data_cpt"),
+      r_dcache_xtn_flush_addr_data("r_dcache_xtn_flush_addr_data"),
+      r_dcache_xtn_state("r_dcache_xtn_state"),
+      r_dcache_xtn_data_addr("r_dcache_xtn_data_addr"),
+      r_dcache_xtn_data_cpt("r_dcache_xtn_data_cpt"),
+      r_dcache_read_state("r_dcache_read_state"),
+
+      r_dcache_paddr_ext("r_dcache_paddr_ext"),
+
       r_vci_cmd_fsm("r_vci_cmd_fsm"),
       r_vci_cmd_min("r_vci_cmd_min"),
@@ -379,7 +418,7 @@
       r_vci_rsp_ins_error("r_vci_rsp_ins_error"),
       r_vci_rsp_data_error("r_vci_rsp_data_error"),
-      r_vci_rsp_fifo_icache("r_vci_rsp_fifo_icache", 2),    // 2 words depth
-      r_vci_rsp_fifo_dcache("r_vci_rsp_fifo_dcache", 2),    // 2 words depth
-      r_vci_rsp_fifo_rpktid("r_vci_rsp_fifo_rpktid", 2),    // 2 words depth
+      r_vci_rsp_fifo_icache("r_vci_rsp_fifo_icache", 2), // 2 words depth
+      r_vci_rsp_fifo_dcache("r_vci_rsp_fifo_dcache", 2), // 2 words depth
+      r_vci_rsp_fifo_rpktid("r_vci_rsp_fifo_rpktid", 2), // 2 words depth
       r_cc_send_data_fifo("r_cc_send_data_fifo", 16),
 
@@ -407,4 +446,8 @@
       r_cc_receive_dcache_updt_tab_idx("r_cc_receive_dcache_updt_tab_idx"),
       r_cc_receive_dcache_nline("r_cc_receive_dcache_nline"),
+      r_cc_receive_dcache_inval_is_config("r_cc_receive_dcache_inval_is_config"),
+
+      r_dspin_clack_req("r_dspin_clack_req"),
+      r_dspin_clack_flit("r_dspin_clack_flit"),
 
       r_iss(this->name(), proc_id),
@@ -412,22 +455,27 @@
       r_icache("icache", icache_ways, icache_sets, icache_words),
       r_dcache("dcache", dcache_ways, dcache_sets, dcache_words),
-      r_itlb("itlb", proc_id, itlb_ways,itlb_sets,vci_param::N),
-      r_dtlb("dtlb", proc_id, dtlb_ways,dtlb_sets,vci_param::N)
+      r_itlb("itlb", proc_id, itlb_ways, itlb_sets, vci_param::N),
+      r_dtlb("dtlb", proc_id, dtlb_ways, dtlb_sets, vci_param::N),
+
+      r_dcache_llsc_paddr("r_dcache_llsc_paddr"),
+      r_dcache_llsc_key("r_dcache_llsc_key"),
+      r_dcache_llsc_count("r_dcache_llsc_count"),
+      r_dcache_llsc_valid("r_dcache_llsc_valid")
 {
     std::cout << "  - Building VciCcVcacheWrapper : " << name << std::endl;
 
-    assert( ((icache_words*vci_param::B) < (1<<vci_param::K)) and
+    assert(((icache_words*vci_param::B) < (1 << vci_param::K)) and
              "Need more PLEN bits.");
 
-    assert( (vci_param::T > 2) and ((1<<(vci_param::T-1)) >= (wbuf_nlines)) and
+    assert((vci_param::T > 2) and ((1 << (vci_param::T - 1)) >= (wbuf_nlines)) and
              "Need more TRDID bits.");
 
-    assert( (icache_words == dcache_words) and
+    assert((icache_words == dcache_words) and
              "icache_words and dcache_words parameters must be equal");
 
-    assert( (itlb_sets == dtlb_sets) and
+    assert((itlb_sets == dtlb_sets) and
              "itlb_sets and dtlb_sets parameters must be equal");
 
-    assert( (itlb_ways == dtlb_ways) and
+    assert((itlb_ways == dtlb_ways) and
              "itlb_ways and dtlb_ways parameters must be equal");
 
@@ -436,15 +484,11 @@
                    (uint32_log2(m_itlb_ways)   << 15)   | (uint32_log2(m_itlb_sets)   << 11) |
                    (uint32_log2(m_icache_ways) << 8)    | (uint32_log2(m_icache_sets) << 4)  |
-                   (uint32_log2(m_icache_words<<2));
-
-    r_mmu_release = (uint32_t)(1 << 16) | 0x1;
-
-    ////////////////////MODIFIED///////////////////////////////
-    //r_dcache_in_tlb        = new bool[dcache_ways*dcache_sets];
-    //r_dcache_contains_ptd  = new bool[dcache_ways*dcache_sets];
-    r_dcache_content_state = new int  [dcache_ways*dcache_sets];
-    r_dcache_dirty_word    = new int  [dcache_ways*dcache_sets*dcache_words];
-    r_dcache_zombi_ncc     = new bool [dcache_ways*dcache_sets];
-    ///////////////////////////////////////////////////////////
+                   (uint32_log2(m_icache_words << 2));
+
+    r_mmu_release = (uint32_t) (1 << 16) | 0x1;
+
+    r_dcache_content_state = new int[dcache_ways * dcache_sets];
+    r_dcache_dirty_word    = new int[dcache_ways * dcache_sets * dcache_words];
+    r_dcache_zombi_ncc     = new bool[dcache_ways * dcache_sets];
 
 
@@ -459,8 +503,8 @@
     typename iss_t::CacheInfo cache_info;
     cache_info.has_mmu = true;
-    cache_info.icache_line_size = icache_words*sizeof(uint32_t);
+    cache_info.icache_line_size = icache_words * sizeof(uint32_t);
     cache_info.icache_assoc = icache_ways;
     cache_info.icache_n_lines = icache_sets;
-    cache_info.dcache_line_size = dcache_words*sizeof(uint32_t);
+    cache_info.dcache_line_size = dcache_words * sizeof(uint32_t);
     cache_info.dcache_assoc = dcache_ways;
     cache_info.dcache_n_lines = dcache_sets;
@@ -475,6 +519,4 @@
     delete [] r_dcache_dirty_word;
     delete [] r_dcache_zombi_ncc;
-    /////////////////////////////////
-    //print_stats();
 }
 
@@ -515,37 +557,37 @@
               << " | MMU = " << r_mmu_mode.read();
 
-    if (r_dcache_updt_req.read() ) std::cout << " | P1_UPDT";
-    if (r_dcache_wbuf_req.read() ) std::cout << " | P1_WBUF";
+    if (r_dcache_updt_req.read()) std::cout << " | P1_UPDT";
+    if (r_dcache_wbuf_req.read()) std::cout << " | P1_WBUF";
     std::cout << std::endl;
 
-    if(mode & 0x01)
-    {
-        if ( r_icache_miss_req.read()     ) std::cout << "  IMISS_REQ" << std::endl;
-        if ( r_icache_unc_req.read()      ) std::cout << "  IUNC_REQ" << std::endl;
-        if ( r_dcache_vci_miss_req.read() ) std::cout << "  DMISS_REQ" << std::endl;
-        if ( r_dcache_vci_unc_req.read()  ) std::cout << "  DUNC_REQ" << std::endl;
-
-        r_wbuf.printTrace((mode>>1)&1);
-    }
-    if(mode & 0x02)
+    if (mode & 0x01)
+    {
+        if (r_icache_miss_req.read())     std::cout << "  IMISS_REQ" << std::endl;
+        if (r_icache_unc_req.read())      std::cout << "  IUNC_REQ" << std::endl;
+        if (r_dcache_vci_miss_req.read()) std::cout << "  DMISS_REQ" << std::endl;
+        if (r_dcache_vci_unc_req.read())  std::cout << "  DUNC_REQ" << std::endl;
+
+        r_wbuf.printTrace((mode >> 1) & 1);
+    }
+    if (mode & 0x02)
     {
         r_iss.dump();
     }
-    if(mode & 0x04)
+    if (mode & 0x04)
     {
         std::cout << "  Data Cache" << std::endl;
         r_dcache.printTrace();
     }
-    if(mode & 0x08)
+    if (mode & 0x08)
     {
         std::cout << "  Instruction Cache" << std::endl;
         r_icache.printTrace();
     }
-    if(mode & 0x10)
+    if (mode & 0x10)
     {
         std::cout << "  Data TLB" << std::endl;
         r_dtlb.printTrace();
     }
-    if(mode & 0x20)
+    if (mode & 0x20)
     {
         std::cout << "  Instruction TLB" << std::endl;
@@ -555,20 +597,20 @@
 
 //////////////////////////////////////////
-tmpl(void)::cache_monitor( paddr_t addr )
+tmpl(void)::cache_monitor(paddr_t addr)
 //////////////////////////////////////////
 {
-    bool        cache_hit;
-    size_t      cache_way = 0;
-    size_t      cache_set = 0;
-    size_t      cache_word = 0;
-    uint32_t    cache_rdata = 0;
-
-    cache_hit = r_dcache.read_neutral( addr,
-                                       &cache_rdata,
-                                       &cache_way,
-                                       &cache_set,
-                                       &cache_word );
-
-    if ( cache_hit != m_debug_previous_d_hit )
+    bool cache_hit;
+    size_t cache_way = 0;
+    size_t cache_set = 0;
+    size_t cache_word = 0;
+    uint32_t cache_rdata = 0;
+
+    cache_hit = r_dcache.read_neutral(addr,
+                                      &cache_rdata,
+                                      &cache_way,
+                                      &cache_set,
+                                      &cache_word);
+
+    if (cache_hit != m_debug_previous_d_hit)
     {
         std::cout << "Monitor PROC " << name()
@@ -581,11 +623,11 @@
     }
 
-    cache_hit = r_icache.read_neutral( addr,
-                                       &cache_rdata,
-                                       &cache_way,
-                                       &cache_set,
-                                       &cache_word );
-
-    if ( cache_hit != m_debug_previous_i_hit )
+    cache_hit = r_icache.read_neutral(addr,
+                                      &cache_rdata,
+                                      &cache_way,
+                                      &cache_set,
+                                      &cache_word);
+
+    if (cache_hit != m_debug_previous_i_hit)
     {
         std::cout << "Monitor PROC " << name()
@@ -609,22 +651,21 @@
         << "- READ RATE               = " << (float)m_cpt_data_read/run_cycles << std::endl
         << "- WRITE RATE              = " << (float)m_cpt_data_write/run_cycles << std::endl
-        << "- IMISS_RATE              = " << (float)m_cpt_ins_miss/m_cpt_ins_read << std::endl
-        << "- DMISS RATE              = " << (float)m_cpt_data_miss/(m_cpt_data_read-m_cpt_unc_read) << std::endl
-        << "- INS MISS COST           = " << (float)m_cost_ins_miss_frz/m_cpt_ins_miss << std::endl
-        << "- DATA MISS COST          = " << (float)m_cost_data_miss_frz/m_cpt_data_miss << std::endl
+        << "- IMISS_RATE              = " << (float)m_cpt_icache_miss/m_cpt_ins_read << std::endl
+        << "- DMISS RATE              = " << (float)m_cpt_dcache_miss/(m_cpt_data_read-m_cpt_unc_read) << std::endl
+        << "- INS MISS COST           = " << (float)m_cost_ins_miss_frz/m_cpt_icache_miss << std::endl
+        << "- DATA MISS COST          = " << (float)m_cost_data_miss_frz/m_cpt_dcache_miss << std::endl
         << "- WRITE COST              = " << (float)m_cost_write_frz/m_cpt_data_write << std::endl
         << "- UNC COST                = " << (float)m_cost_unc_read_frz/m_cpt_unc_read << std::endl
         << "- UNCACHED READ RATE      = " << (float)m_cpt_unc_read/m_cpt_data_read << std::endl
         << "- CACHED WRITE RATE       = " << (float)m_cpt_write_cached/m_cpt_data_write << std::endl
-        << "- INS TLB MISS RATE       = " << (float)m_cpt_ins_tlb_miss/m_cpt_ins_tlb_read << std::endl
-        << "- DATA TLB MISS RATE      = " << (float)m_cpt_data_tlb_miss/m_cpt_data_tlb_read << std::endl
-        << "- ITLB MISS COST          = " << (float)m_cost_ins_tlb_miss_frz/m_cpt_ins_tlb_miss << std::endl
-        << "- DTLB MISS COST          = " << (float)m_cost_data_tlb_miss_frz/m_cpt_data_tlb_miss << std::endl
-        << "- ITLB UPDATE ACC COST    = " << (float)m_cost_ins_tlb_update_acc_frz/m_cpt_ins_tlb_update_acc << std::endl
-        << "- DTLB UPDATE ACC COST    = " << (float)m_cost_data_tlb_update_acc_frz/m_cpt_data_tlb_update_acc << std::endl
+        << "- INS TLB MISS RATE       = " << (float)m_cpt_itlb_miss/m_cpt_itlb_read << std::endl
+        << "- DATA TLB MISS RATE      = " << (float)m_cpt_dtlb_miss/m_cpt_dtlb_read << std::endl
+        << "- ITLB MISS COST          = " << (float)m_cost_ins_tlb_miss_frz/m_cpt_itlb_miss << std::endl
+        << "- DTLB MISS COST          = " << (float)m_cost_data_tlb_miss_frz/m_cpt_dtlb_miss << std::endl
+        << "- ITLB UPDATE ACC COST    = " << (float)m_cost_ins_tlb_update_acc_frz/m_cpt_itlb_write << std::endl
+        << "- DTLB UPDATE ACC COST    = " << (float)m_cost_data_tlb_update_acc_frz/m_cpt_dtlb_write << std::endl
         << "- DTLB UPDATE DIRTY COST  = " << (float)m_cost_data_tlb_update_dirty_frz/m_cpt_data_tlb_update_dirty << std::endl
-        << "- ITLB HIT IN DCACHE RATE = " << (float)m_cpt_ins_tlb_hit_dcache/m_cpt_ins_tlb_miss << std::endl
-        << "- DTLB HIT IN DCACHE RATE = " << (float)m_cpt_data_tlb_hit_dcache/m_cpt_data_tlb_miss << std::endl
-        //<< "- DCACHE FROZEN BY ITLB   = " << (float)m_cost_ins_tlb_occup_cache_frz/m_cpt_dcache_frz_cycles << std::endl
+        << "- ITLB HIT IN DCACHE RATE = " << (float)m_cpt_ins_tlb_hit_dcache/m_cpt_itlb_miss << std::endl
+        << "- DTLB HIT IN DCACHE RATE = " << (float)m_cpt_data_tlb_hit_dcache/m_cpt_dtlb_miss << std::endl
         << "- DCACHE FOR TLB %        = " << (float)m_cpt_tlb_occup_dcache/(m_dcache_ways*m_dcache_sets) << std::endl
         << "- NB CC BROADCAST         = " << m_cpt_cc_broadcast << std::endl
@@ -666,104 +707,47 @@
 ////////////////////////
 {
-    m_cpt_dcache_data_read  = 0;
+    m_cpt_dcache_data_read = 0;
     m_cpt_dcache_data_write = 0;
-    m_cpt_dcache_dir_read   = 0;
-    m_cpt_dcache_dir_write  = 0;
-    m_cpt_icache_data_read  = 0;
+    m_cpt_dcache_dir_read = 0;
+    m_cpt_dcache_dir_write = 0;
+    m_cpt_icache_data_read = 0;
     m_cpt_icache_data_write = 0;
-    m_cpt_icache_dir_read   = 0;
-    m_cpt_icache_dir_write  = 0;
-
-    m_cpt_frz_cycles        = 0;
-//    m_cpt_dcache_frz_cycles = 0;
-    m_cpt_total_cycles      = 0;
-
-//    m_cpt_read         = 0;
-//    m_cpt_write        = 0;
-    m_cpt_data_miss    = 0;
-    m_cpt_ins_miss     = 0;
-    m_cpt_unc_read     = 0;
-    m_cpt_write_cached = 0;
-    m_cpt_ins_read     = 0;
-
-    m_cost_write_frz     = 0;
+    m_cpt_icache_dir_read = 0;
+    m_cpt_icache_dir_write = 0;
+
+    m_cpt_frz_cycles = 0;
+    m_cpt_total_cycles = 0;
+
+    m_cpt_data_read = 0;
+    m_cpt_data_write = 0;
+    m_cpt_data_write_back = 0;
+    m_cpt_data_cleanup = 0;
+    m_cpt_data_sc = 0;
+
+    m_cpt_dcache_miss = 0;
+    m_cpt_icache_miss = 0;
+    m_cpt_ins_read = 0;
+
     m_cost_data_miss_frz = 0;
-    m_cost_unc_read_frz  = 0;
-    m_cost_ins_miss_frz  = 0;
-
-    m_cpt_imiss_transaction      = 0;
-    m_cpt_dmiss_transaction      = 0;
-    m_cpt_unc_transaction        = 0;
-    m_cpt_write_transaction      = 0;
-    m_cpt_icache_unc_transaction = 0;
-
-    m_cost_imiss_transaction      = 0;
-    m_cost_dmiss_transaction      = 0;
-    m_cost_unc_transaction        = 0;
-    m_cost_write_transaction      = 0;
-    m_cost_icache_unc_transaction = 0;
-    m_length_write_transaction    = 0;
-
-    m_cpt_ins_tlb_read       = 0;
-    m_cpt_ins_tlb_miss       = 0;
-    m_cpt_ins_tlb_update_acc = 0;
-
-    m_cpt_data_tlb_read         = 0;
-    m_cpt_data_tlb_miss         = 0;
-    m_cpt_data_tlb_update_acc   = 0;
-    m_cpt_data_tlb_update_dirty = 0;
-    m_cpt_ins_tlb_hit_dcache    = 0;
-    m_cpt_data_tlb_hit_dcache   = 0;
-    m_cpt_ins_tlb_occup_cache   = 0;
-    m_cpt_data_tlb_occup_cache  = 0;
-
-    m_cost_ins_tlb_miss_frz          = 0;
-    m_cost_data_tlb_miss_frz         = 0;
-    m_cost_ins_tlb_update_acc_frz    = 0;
-    m_cost_data_tlb_update_acc_frz   = 0;
-    m_cost_data_tlb_update_dirty_frz = 0;
-    m_cost_ins_tlb_occup_cache_frz   = 0;
-    m_cost_data_tlb_occup_cache_frz  = 0;
-
-    m_cpt_itlbmiss_transaction      = 0;
-    m_cpt_itlb_ll_transaction       = 0;
-    m_cpt_itlb_sc_transaction       = 0;
-    m_cpt_dtlbmiss_transaction      = 0;
-    m_cpt_dtlb_ll_transaction       = 0;
-    m_cpt_dtlb_sc_transaction       = 0;
-    m_cpt_dtlb_ll_dirty_transaction = 0;
-    m_cpt_dtlb_sc_dirty_transaction = 0;
-
-    m_cost_itlbmiss_transaction      = 0;
-    m_cost_itlb_ll_transaction       = 0;
-    m_cost_itlb_sc_transaction       = 0;
-    m_cost_dtlbmiss_transaction      = 0;
-    m_cost_dtlb_ll_transaction       = 0;
-    m_cost_dtlb_sc_transaction       = 0;
-    m_cost_dtlb_ll_dirty_transaction = 0;
-    m_cost_dtlb_sc_dirty_transaction = 0;
-
-//    m_cpt_cc_update_data = 0;
-//    m_cpt_cc_inval_ins   = 0;
-//    m_cpt_cc_inval_data  = 0;
-    m_cpt_cc_broadcast   = 0;
-
-    m_cost_updt_data_frz  = 0;
-    m_cost_inval_ins_frz  = 0;
-    m_cost_inval_data_frz = 0;
-    m_cost_broadcast_frz  = 0;
-
-    m_cpt_cc_cleanup_data = 0;
-    m_cpt_cc_cleanup_ins  = 0;
-
-    m_cpt_cleanup_data_not_dirty  = 0;
+    m_cost_ins_miss_frz = 0;
+
+    m_cpt_write_transaction = 0;
+    m_length_write_transaction = 0;
+
+    m_cpt_itlb_read = 0;
+    m_cpt_itlb_miss = 0;
+    m_cpt_itlb_write = 0;
+    m_cost_ins_tlb_miss_frz = 0;
+
+    m_cpt_dtlb_read = 0;
+    m_cpt_dtlb_miss = 0;
+    m_cpt_dtlb_write = 0;
+
+    m_cpt_cleanup_data_not_dirty = 0;
     m_cpt_cleanup_data_dirty_word = 0;
     m_cpt_data_write_miss = 0;
     m_cpt_data_write_on_zombi = 0;
     m_cpt_data_write_on_zombi_ncc = 0;
-
 }
-
-
 
 /////////////////////////
@@ -771,5 +755,5 @@
 /////////////////////////
 {
-    if ( not p_resetn.read() )
+    if (not p_resetn.read())
     {
         r_iss.reset();
@@ -780,10 +764,10 @@
         r_dtlb.reset();
 
-        r_dcache_fsm      = DCACHE_IDLE;
-        r_icache_fsm      = ICACHE_IDLE;
-        r_vci_cmd_fsm     = CMD_IDLE;
-        r_vci_rsp_fsm     = RSP_IDLE;
-        r_cc_receive_fsm  = CC_RECEIVE_IDLE;
-        r_cc_send_fsm     = CC_SEND_IDLE;
+        r_dcache_fsm     = DCACHE_IDLE;
+        r_icache_fsm     = ICACHE_IDLE;
+        r_vci_cmd_fsm    = CMD_IDLE;
+        r_vci_rsp_fsm    = RSP_IDLE;
+        r_cc_receive_fsm = CC_RECEIVE_IDLE;
+        r_cc_send_fsm    = CC_SEND_IDLE;
 
         // reset data physical address extension
@@ -794,9 +778,9 @@
 
         // reset dcache directory extension
-        for (size_t i=0 ; i< m_dcache_ways*m_dcache_sets ; i++)
+        for (size_t i = 0; i < m_dcache_ways * m_dcache_sets; i++)
         {
             r_dcache_content_state[i] = LINE_CACHE_DATA_NOT_DIRTY;
-            r_dcache_dirty_word[i]    = 0;
-            r_dcache_zombi_ncc[i]     = false;
+            r_dcache_dirty_word[i] = 0;
+            r_dcache_zombi_ncc[i] = false;
         }
 
@@ -838,5 +822,7 @@
 
         // No request from DCACHE FSM to CC_SEND FSM
-        r_dcache_cc_send_req       = false;
+        r_dcache_cc_send_req        = false;
+        r_dcache_cleanup_victim_req = false;
+
         r_dcache_clack_req         = false;
 
@@ -867,14 +853,11 @@
         m_debug_activated          = false;
 
-        // SPECIAL REGISTERS ODCCP
+        // RWT
         r_dcache_cc_cleanup_updt_data = false;
         r_dcache_cc_cleanup_line_ncc  = false;
-        r_dcache_miss_victim_no_coherence = false;
-        r_dcache_line_no_coherence = false;
         r_cc_send_cpt_word = 0;
         r_dcache_miss_data_cpt = 0;
         r_dcache_miss_data_addr = 0;
 
-        r_dcache_cleanup_victim_req = false;
         r_dcache_cleanup_victim_line_ncc = false;
         r_dcache_cleanup_victim_updt_data = false;
@@ -894,5 +877,7 @@
         m_cpt_stop_simulation   = 0;
 
-        m_cpt_data_miss         = 0;
+        m_cpt_data_read         = 0;
+
+        m_cpt_dcache_miss       = 0;
         m_cpt_data_write        = 0;
         m_cpt_data_sc           = 0;
@@ -900,5 +885,5 @@
         m_cpt_data_cleanup      = 0;
         m_cpt_cleanup_data_not_dirty = 0;
-        m_cpt_ins_miss          = 0;
+        m_cpt_icache_miss       = 0;
         m_cpt_unc_read          = 0;
         m_cpt_write_cached      = 0;
@@ -910,9 +895,11 @@
         m_cost_ins_miss_frz     = 0;
 
+        m_cpt_dunc_transaction  = 0;
+        m_cpt_ll_transaction    = 0;
+
         m_cpt_imiss_transaction = 0;
         m_cpt_dmiss_transaction = 0;
         m_cpt_unc_transaction   = 0;
         m_cpt_write_transaction = 0;
-        m_cpt_icache_unc_transaction = 0;
 
         m_cost_imiss_transaction      = 0;
@@ -920,19 +907,18 @@
         m_cost_unc_transaction        = 0;
         m_cost_write_transaction      = 0;
-        m_cost_icache_unc_transaction = 0;
         m_length_write_transaction    = 0;
 
-        m_cpt_ins_tlb_read       = 0;
-        m_cpt_ins_tlb_miss       = 0;
-        m_cpt_ins_tlb_update_acc = 0;
-
-        m_cpt_data_tlb_read         = 0;
-        m_cpt_data_tlb_miss         = 0;
-        m_cpt_data_tlb_update_acc   = 0;
+        m_cpt_itlb_read  = 0;
+        m_cpt_itlb_miss  = 0;
+        m_cpt_itlb_write = 0;
+
+        m_cpt_dtlb_read  = 0;
+        m_cpt_dtlb_miss  = 0;
+        m_cpt_dtlb_write = 0;
+
+        m_cpt_tlb_occup_dcache      = 0;
         m_cpt_data_tlb_update_dirty = 0;
         m_cpt_ins_tlb_hit_dcache    = 0;
         m_cpt_data_tlb_hit_dcache   = 0;
-        m_cpt_ins_tlb_occup_cache   = 0;
-        m_cpt_data_tlb_occup_cache  = 0;
 
         m_cost_ins_tlb_miss_frz          = 0;
@@ -941,11 +927,8 @@
         m_cost_data_tlb_update_acc_frz   = 0;
         m_cost_data_tlb_update_dirty_frz = 0;
-        m_cost_ins_tlb_occup_cache_frz   = 0;
-        m_cost_data_tlb_occup_cache_frz  = 0;
-
-        m_cpt_ins_tlb_inval       = 0;
-        m_cpt_data_tlb_inval      = 0;
-        m_cost_ins_tlb_inval_frz  = 0;
-        m_cost_data_tlb_inval_frz = 0;
+
+        m_cpt_cc_update_dcache = 0;
+        m_cpt_cc_inval_icache  = 0;
+        m_cpt_cc_inval_dcache  = 0;
 
         m_cpt_cc_broadcast   = 0;
@@ -966,33 +949,13 @@
 
         m_cpt_itlbmiss_transaction      = 0;
-        m_cpt_itlb_ll_transaction       = 0;
-        m_cpt_itlb_sc_transaction       = 0;
         m_cpt_dtlbmiss_transaction      = 0;
-        m_cpt_dtlb_ll_transaction       = 0;
-        m_cpt_dtlb_sc_transaction       = 0;
-        m_cpt_dtlb_ll_dirty_transaction = 0;
-        m_cpt_dtlb_sc_dirty_transaction = 0;
 
         m_cost_itlbmiss_transaction      = 0;
-        m_cost_itlb_ll_transaction       = 0;
-        m_cost_itlb_sc_transaction       = 0;
         m_cost_dtlbmiss_transaction      = 0;
-        m_cost_dtlb_ll_transaction       = 0;
-        m_cost_dtlb_sc_transaction       = 0;
-        m_cost_dtlb_ll_dirty_transaction = 0;
-        m_cost_dtlb_sc_dirty_transaction = 0;
-/*
-        m_cpt_dcache_frz_cycles = 0;
-        m_cpt_read              = 0;
-        m_cpt_write             = 0;
-        m_cpt_cc_update_data = 0;
-        m_cpt_cc_inval_ins   = 0;
-        m_cpt_cc_inval_data  = 0;
-*/
-
-        for (uint32_t i=0; i<32 ; ++i) m_cpt_fsm_icache      [i]   = 0;
-        for (uint32_t i=0; i<32 ; ++i) m_cpt_fsm_dcache      [i]   = 0;
-        for (uint32_t i=0; i<32 ; ++i) m_cpt_fsm_cmd         [i]   = 0;
-        for (uint32_t i=0; i<32 ; ++i) m_cpt_fsm_rsp         [i]   = 0;
+
+        for (uint32_t i = 0; i < 32; ++i) m_cpt_fsm_icache[i] = 0;
+        for (uint32_t i = 0; i < 32; ++i) m_cpt_fsm_dcache[i] = 0;
+        for (uint32_t i = 0; i < 32; ++i) m_cpt_fsm_cmd[i] = 0;
+        for (uint32_t i = 0; i < 32; ++i) m_cpt_fsm_rsp[i] = 0;
 
         // init the llsc reservation buffer
